require "src/button"
function love.load()
    SCREEN_WIDTH, SCREEN_HEIGHT = love.window.getDesktopDimensions()
    love.window.setMode(SCREEN_WIDTH / 2, SCREEN_HEIGHT /2 , {resizable=false, vsync=0, minwidth=400, minheight=300})
    RES = 10

    canPlace = true 

    WIDTH = SCREEN_WIDTH / 2 /  RES - 1
    HEIGHT = SCREEN_HEIGHT / 2 / RES - 1
    
    fps = 0 
    desFps = 10
    time = 0
    gen = 0
    lastgen = 0

    vInput = ""
    button_x = 0
    button_y = 0 
    buttons = {}
    b = button.new(button_x, button_y, 100, 30, "Pause", "pause")
    button_y = button_y + 32
    table.insert(buttons, b)
    b = button.new(button_x, 32, 100, 30, "=>", "nextGen")
    button_y = button_y + 32
    table.insert(buttons, b)
    b = button.new(button_x, 64, 100, 30, "Randomize", "random")
    button_y = button_y + 32
    table.insert(buttons, b)
    b = button.new(button_x, 64 + 32, 100, 30, "Clear", "clear")
    button_y = button_y + 32
    table.insert(buttons, b)
    b = button.new(button_x + 102, 1, 10, 31 * 4, "<", "hide")
    button_y = button_y + 32
    table.insert(buttons, b)
    hidden = false 

    button_x = 0

    font = love.graphics.setNewFont(16)

    grid = {}
    empty = {}
    pause = true
    for y=0, HEIGHT do 
        grid[y] = {}
        empty[y] = {}
        for x=0, WIDTH do 
            grid[y][x] = 0
            empty[y][x] = 0
        end
    end
    newGen = empty
    love.graphics.setBackgroundColor(1,1, 1)
end

function love.update(dt)
    fps = love.timer.getFPS()
    step = fps/desFps 
    time = time + 1
    if pause == false and time%math.ceil(step)==0 then
        gen = gen + 1
        time = 0
    end
    if gen > lastgen then 
        lastgen = gen
        produceNextGen()
    end
    touchInput()
    for i, b in ipairs(buttons) do 
        b:update()
    end
    if hidden == true then
        if math.floor(button_x) > -100 then 
            button_x = button_x - 500 * dt
        elseif button_x < -100 then
            button_x = -100
        end 
    else
        if math.ceil(button_x) < -4 then
            button_x = button_x + 500 * dt
        elseif button_x > -4 then 
            button_x = -4
        end
    end
end



function love.draw()
    love.graphics.push()
    for y, xs in ipairs(grid) do 
        for x, value in ipairs(xs) do 
            if value == 1 then 
                    love.graphics.setColor(0, 0, 0)
                love.graphics.rectangle("fill", (x) * RES, (y) * RES, RES, RES)
            end
        end
    end
    love.graphics.pop()
    love.graphics.setColor(0, 0, 0)
    for i, b in ipairs(buttons) do 
        b:draw()
    end
end

function touchInput()
    if vInput == "pause" then
        canPlace = true
        vInput = ""
        if pause == true then 
            pause = false
            hidden = true
        else 
            pause = true
        end
    end
    if vInput == "hide" then 
        canPlace = true
        vInput = ""
        if hidden == true then 
            hidden = false
        else
            hidden = true
        end
    end
    if vInput == "nextGen" and pause == true then 
        gen = gen + 1
        canPlace = true
        vInput = ""
    end
    if vInput == "random" then
        canPlace = true
        vInput = "" 
        for y=0, HEIGHT do 
            grid[y] = {}
            newGen[y] = {}
            for x=0, WIDTH do
                local ran = love.math.random(0, 1) 
                grid[y][x] = ran
                newGen[y][x] = ran
            end
        end
    end
    if vInput == "clear" then
        canPlace = true
        vInput = "" 
        for y=0, HEIGHT do 
            grid[y] = {}
            newGen[y] = {}
            for x=0, WIDTH do
                grid[y][x] = 0
                newGen[y][x] = 0
            end
        end
    end
end

function love.keypressed(key)
    
    --switches between fullscreen and windowed
    if key == "f11" then 
        if love.window.getFullscreen() == true then 
            love.window.setFullscreen(false)
            RES = RES / 2
        else 
            love.window.setFullscreen(true)
            RES = RES * 2
        end
    end
    --allows to evolve the next gen in pause mode
    if key == "w" and pause == true then 
        gen = gen + 1
    end
    --randomizes the board
    if key == "r" then 
        for y=0, HEIGHT do 
            grid[y] = {}
            newGen[y] = {}
            for x=0, WIDTH do
            local ran = love.math.random(0, 1) 
                grid[y][x] = ran
                newGen[y][x] = ran
            end
        end
    end
    --wipes/cleans the board (all cells are now dead)
    if key == "c" then 
        for y=0, HEIGHT do 
            grid[y] = {}
            newGen[y] = {}
            for x=0, WIDTH do
                grid[y][x] = 0
                newGen[y][x] = 0
            end
        end
    end
    --sets pause on or of
    if key == "space" then 
        if pause == true then 
            pause = false
        else 
            pause = true
        end
    end
    if key == "lshift" then 
        if hidden == true then 
            hidden = false
        else
            hidden = true
        end
    end
end

function love.mousepressed(x, y, button)
    for i, b in ipairs(buttons) do 
        b:press(x, y, button)
    end
    --lets you change cell state at the mouse coordinate
    if love.mouse.isDown(1) and canPlace == true then 
        local x, y = math.floor(x/RES), math.floor(y/RES)
        if grid[y][x] == 1 then 
            grid[y][x] = 0
        else 
            grid[y][x] = 1
        end
    end
    
end


function produceNextGen()
    --newGen gets cleared
    newGen = empty
    for y, xs in ipairs(empty) do 
        for x, value in ipairs(xs) do 
            newGen[y][x] = empty[y][x]
        end
    end

    --counts the neighboors and decides wether a cell will be dead or alive in the next generation
    dxys = { {x=0,y=-1},{x=1,y=-1},{x=1,y=0},{x=1,y=1},{x=0,y=1},{x=-1,y=1},{x=-1,y=0},{x=-1,y=-1},}
    for y, xs in ipairs(grid) do 
        for x, value in ipairs(xs) do 
            local totalN = 0
            for k, dxy in ipairs(dxys) do
                local x0 =  x
                local y0 = y
                local xw, yw = x0+dxy.x, y0+dxy.y
                totalN = totalN + getValue(grid, xw, yw, WIDTH, HEIGHT )
            end
              
            if value == 1 then 
                totalN = totalN- 1
                if totalN > 3 then --death by overpopulation default: >3
                    newGen[y][x] = 0
                elseif totalN < 2 then --death by underpopulation defaul: <2
                    newGen[y][x] = 0
                else---stays alive when above isnt true
                    newGen[y][x] = 1
                end
            end
            if value == 0 then 
                if totalN == 3 then --birth default: == 3
                    newGen[y][x] = 1
                end
            end
        end
    end
    --assigns each x and y of the newgen to the grid table
    for y, xs in ipairs(grid) do 
        for x, value in ipairs(xs) do 
            grid[y][x] = newGen[y][x]
        end
    end

end



function getValue (map, x, y, w, h)
    x = (x-1)%w+1
    y = (y-1)%h+1
    return map[y][x]
  end